﻿Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        If EncodingUsed(TextBox1.Text) = "80" Then
            Me.TextBox2.Text = "0x80"
            Me.TextBox3.Text = Decoding80(TextBox1.Text)

        ElseIf EncodingUsed(TextBox1.Text) = "81" Then
            Me.TextBox2.Text = "0x81"
            Me.TextBox3.Text = Decoding81(TextBox1.Text)

        ElseIf EncodingUsed(TextBox1.Text) = "82" Then
            Me.TextBox2.Text = "0x82"
            Me.TextBox3.Text = Decoding82(TextBox1.Text)

        Else
            Me.TextBox3.Text = "Invalid alpha field"
        End If

    End Sub

    Function EncodingUsed(ByVal alphaField As String) As String

        Dim first2character As String

        first2character = alphaField.Substring(0, 2)

        If first2character = "80" Then
            Return "80"
        ElseIf first2character = "81" Then
            Return "81"
        ElseIf first2character = "82" Then
            Return "82"
        Else
            Return "99"
        End If

    End Function

    Function Decoding80(ByVal alphaField As String) As String

        '80005200650074006F00750072FFFF = Retuor
        Dim myString As String
        myString = alphaField.Remove(0, 2) 'Remove encoding used
        Dim convertedText As System.Text.StringBuilder = New System.Text.StringBuilder

        For i As Integer = 0 To myString.Length Step 4
            'NKL: keep looping until "FFFF" is found 
            If (myString.Substring(i, 4) = "FFFF") Then
                Exit For
            Else
                'NKL: to convert to UCS2 character
                convertedText.Append(ChrW(Convert.ToByte(myString.Substring(i, 4), 16)))
            End If

        Next

        Return convertedText.ToString

    End Function
    Function Decoding81(ByVal alphaField As String) As String

        '810E00C4E5F2EEE9E5F220F4F2E1EEF3AE = Dernier trans.
        '810500D3EFECE4E5 = Solde
        Dim myString As String
        Dim byte_2 As Integer
        Dim byte_3 As String
        Dim currentByte As String
        Dim currentByteAsBinary As String
        Dim c As Integer
        Dim BinString As String
        Dim BinStringAsHex As String
        Dim convertedText As System.Text.StringBuilder = New System.Text.StringBuilder

        myString = alphaField.Remove(0, 2) 'remove 81 from alpha field
        byte_2 = Convert.ToInt32(myString.Substring(0, 2), 16) 'number of character in string

        Dim b As Integer = Convert.ToInt32(myString.Substring(2, 2), 16)
        byte_3 = Convert.ToString(b, 2).PadLeft(8, "0"c) ' get binary reprentation of byte pattern

        myString = myString.Remove(0, 4) 'get only byte of character ie: remove character number and byte pattern

        'NKL: no. of loops is defined by byte_2
        For i As Integer = 0 To byte_2 * 2 - 2 Step 2 'loop for how many character are inside; 

            currentByte = myString.Substring(i, 2)
            c = Convert.ToInt32(currentByte, 16)

            currentByteAsBinary = Convert.ToString(c, 2).PadLeft(8, "0") 'convert to binary

            'check if the bit no. 8 of the byte is 0
            If (currentByteAsBinary.Substring(0, 1) = "0") Then
                convertedText.Append(ChrW(Convert.ToByte(currentByte, 16))) 'convert directly to char

            Else
                'NKL: the bit 8 of the byte is "1", then construct a 16 bit using this format -- "0" + <byte pattern defined by byte no. 3, static> + "remaining bits of current byte"
                BinString = "0" + byte_3 + currentByteAsBinary.Substring(1, 7)
                'NKL: convert 16 bit binary string to HEX
                BinStringAsHex = Hex(Convert.ToInt32(BinString, 2))
                'NKL: convert HEX to UCS2 character
                convertedText.Append(ChrW(Convert.ToByte(BinStringAsHex, 16)))

            End If

        Next

        Return convertedText.ToString

    End Function
    Function Decoding82(ByVal alphaField As String) As String
        'In Future progress
        Return alphaField
    End Function

End Class
