﻿
Option Explicit On

Module Module1

    Public Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)


    Public Modem As New MobitekSTK6.Modem
    Public SMS As New MobitekSTK6.SMS
    Public STKAPI As New MobitekSTK6.SIMToolKit
    Public USSD As New MobitekSTK6.USSD

    Public Sub InitModem()
        Dim intModemStatus As Integer



        frmSTK.txtText.Text = "Connecting to STK Modem ..."
        'Initialised the modem at COM port 7 ie. to establish connection btw. PC and GSM modem
        'Please change the COM port number accordingly, please refer to the Installation Guide on how to find the COM Port number


        intModemStatus = Modem.Init(frmSTK.txtPort.Text, "")


        Select Case intModemStatus

            Case 0
                frmSTK.txtText.Text = "GSM Modem Not Connected!"
                Exit Sub

            Case 1
                frmSTK.txtText.Text = "STK Modem Connected!"
                Exit Sub

            Case 2
                frmSTK.txtText.Text = "PIN Required!"
                Exit Sub

            Case 3
                frmSTK.txtText.Text = "Incorrect PIN entered! Warning: after 3 tries of incorrect PIN entered, your SIM card will be blocked by TELCO!"
                Exit Sub

            Case 4
                frmSTK.txtText.Text = "Your SIM card is blocked by TELCO!"
                Exit Sub

            Case 5
                frmSTK.txtText.Text = "Your SIM card has problem!"
                Exit Sub

            Case Else
                frmSTK.txtText.Text = "GSM Modem Not Connected!"
                Exit Sub

        End Select


        '    'You can use this API function anywhere in your code to check the modem's connection to GSM network
        '    If SMS.ConnectToGSM = True Then
        '
        '        frmSTK.txtText= "GSM modem is connected to GSM Network."
        '    Else
        '        frmSTK.txtText= "GSM modem is disconnected from the GSM Network. Please re-initialised GSM modem."
        '
        '        'Close modem connection to PC
        '        SMS.CloseModem
        '        Set SMS = Nothing
        '
        '        Exit Sub
        '    End If
    End Sub


    'Public Function FindModem() As Integer

    '    Dim iCOM As Integer

    '    iCOM = Modem.FindCOMPort(1, 255)
    '    FindModem = iCOM

    'End Function

    Public Function ConvertToUnicode(ByVal strOrigianlMsg As String) As String

        Dim arrByte() As Byte
        Dim strNumbers As System.Text.StringBuilder = New System.Text.StringBuilder
        Dim hexNumbers As System.Text.StringBuilder = New System.Text.StringBuilder
        Dim sHEX As String


        arrByte = System.Text.Encoding.BigEndianUnicode.GetBytes(strOrigianlMsg)
        For Each item As Byte In arrByte
            'convert byte to string type and append the string value into the "strNumbers"
            strNumbers.Append((item).ToString)
        Next

        For i As Integer = 0 To arrByte.Length - 1
            'convert byte to hexadecimal type
            sHEX = arrByte(i).ToString("x")
            'if length is less than 2 character, then add "0" in front
            If Len(sHEX) < 2 Then
                sHEX = "0" & sHEX
            End If

            hexNumbers.Append(sHEX)
        Next

        'convert hex/UTF-16 to string
        ConvertToUnicode = hexNumbers.ToString()

    End Function
End Module
