﻿Public Class frmSMS
    Private Sub cmdOnline_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOnline.Click
        If SMS.IsOnline(Me.txtTo.Text, 12) = True Then
            MsgBox("The recipient is on-line!", vbInformation)
        Else
            MsgBox("The recipient is NOT on-line!", vbInformation)
        End If
    End Sub

    Private Sub cmdSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSend.Click
        SMS.DeliveryReportOn()

        If Len(Me.txtMsg.Text) < 160 Then

            If SMS.SendSMSText(Me.txtTo.Text, Me.txtMsg.Text) = True Then

                MsgBox("Message sent!", vbInformation)
            Else
                MsgBox("Message NOT sent!", vbInformation)
            End If
        Else
            If SMS.SendLMSText(Me.txtTo.Text, Me.txtMsg.Text, 100) = True Then

                MsgBox("Message sent!", vbInformation)
            Else
                MsgBox("Message NOT sent!", vbInformation)
            End If

        End If
    End Sub

    Private Sub cmdRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRead.Click
        '[VB - frmSMS] Private Sub cmdRead_Click()

        If SMS.ReadSMS = True Then
            Me.txtFrom.Text = SMS.MN
            Me.txtIn.Text = SMS.Msg
            Me.txtDateTime.Text = SMS.SCTS
        Else
            MsgBox("No incoming SMS!", vbInformation)
        End If
    End Sub

    Private Sub cmdReadText_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReadText.Click
        
        If SMS.ReadSMSText = True Then
            Me.txtFrom.Text = SMS.MN
            Me.txtIn.Text = SMS.Msg
            Me.txtDateTime.Text = SMS.SCTS

            If SMS.IsLMS = True Then
                MsgBox("This is a long message. Message reference number is: " & SMS.LMS_Reference & vbCrLf & _
                "Total number of parts is: " & SMS.LMS_Total & vbCrLf & _
                "This message is part number: " & SMS.LMS_Sequence & vbCrLf & _
                "You need to join the message by matching the reference number of each different parts and according to their sequence.")

            End If
        Else
            MsgBox("No incoming SMS!", vbInformation)
        End If
    End Sub

    Private Sub cmdReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReport.Click

        If SMS.GetDeliveryReport = True Then
            'If delivery status report is "DELIVERED" then ...
            If SMS.DRStatus = MobitekSTK6.DeliveryStatus.Delivered Then
                MsgBox("The outgoing SMS with reference number: " & SMS.DRMsgRef & vbCrLf & _
                "was received by the SMSC" & vbCrLf & _
                "on: " & SMS.DRRDate & vbCrLf & _
                "at: " & SMS.DRRTime & vbCrLf & _
                "and was successfully delivered to: " & SMS.DRMNRecipient & vbCrLf & _
                "on: " & SMS.DRFDate & vbCrLf & _
                "at: " & SMS.DRFTime)

                'else if delivery status report is "UNDELIVERED" then ...
            ElseIf SMS.DRStatus = MobitekSTK6.DeliveryStatus.Undelivered Then
                MsgBox("The outgoing SMS with reference number: " & SMS.DRMsgRef & vbCrLf & _
                "was received by the SMSC" & vbCrLf & _
                "on: " & SMS.DRRDate & vbCrLf & _
                "at: " & SMS.DRRTime & vbCrLf & _
                "was NOT successfully delivered to: " & SMS.DRMNRecipient)

                'else if delivery status report is "UNKNOWN" then ...
            ElseIf SMS.DRStatus = MobitekSTK6.DeliveryStatus.Unknown Then
                MsgBox("The outgoing SMS with reference number: " & SMS.DRMsgRef & vbCrLf & _
                "was received by the SMSC on: " & SMS.DRRDate & vbCrLf & _
                "at: " & SMS.DRRTime & vbCrLf & _
                "has a delivery status --- UNKNOWN")

            End If
        Else

            MsgBox("No report available!")

        End If
    End Sub

    Private Sub cmdSendU_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSendU.Click
        SMS.DeliveryReportOn()

        If Len(Me.txtMsg.Text) < 160 Then

            If SMS.SendSMSUnicode(Me.txtTo.Text, Me.txtMsg.Text) = True Then

                MsgBox("Message sent!", vbInformation)
            Else
                MsgBox("Message NOT sent!", vbInformation)
            End If
        Else
            If SMS.SendLMSText(Me.txtTo.Text, Me.txtMsg.Text, 100) = True Then

                MsgBox("Message sent!", vbInformation)
            Else
                MsgBox("Message NOT sent!", vbInformation)
            End If

        End If
    End Sub
End Class